

const geolocationSpoofer = async () => {

	console.log("Swiperino Geolocation On");

	let overrideLocation = false;
	let realLat = null;
	let realLong = null;

	if (!window.navigator.geolocation) {
		console.log("Geolocation is not supported by this browser.")
	  return;
	}

	if(localStorage.getItem("swpzCurrentLatitude") !== null){
		localStorage.removeItem("swpzCurrentLatitude");
	}
	if(localStorage.getItem("swpzCurrentLongitude") !== null){
		localStorage.removeItem("swpzCurrentLongitude");
	}

	function isFloatOrInt(n){
	  return (Number(n) === n && n % 1 !== 0) || Number.isInteger(n);
	}

	if(localStorage.getItem("swpza") !== null && localStorage.getItem("swpzo") !== null){

		await window.navigator.geolocation.watchPosition((position) => {
			realLat = position.coords.latitude;
			realLong = position.coords.longitude;
			// console.log("set realLat",realLat,"set realLong",realLong);
		});

		const lat = parseFloat(localStorage.getItem("swpza"));
		const long = parseFloat(localStorage.getItem("swpzo"));

		// console.log("one 1")
		getLocation();
		getWatchLocation();
		if(isFloatOrInt(lat) && isFloatOrInt(long)){
			overrideLocation = true;
			overWriteGeolocation();			
		}
		// console.log("two 2")
		getLocation();
		getWatchLocation();
	}
	function overWriteGeolocation(){
		// console.log("overWriteGeolocation");

		window.navigator.geolocation.getCurrentPosition = function(success, error, options) { 
			const lat = parseFloat(localStorage.getItem("swpza"));
			const long = parseFloat(localStorage.getItem("swpzo"));
			// console.log("setting Lat",lat);
			// console.log("setting long",long);
		  success({ coords: { 
		      latitude: lat, 
		      longitude: long,
		  }, timestamp: Date.now() });
		}
		window.navigator.geolocation.watchPosition = function(success, error, options){
			const lat = parseFloat(localStorage.getItem("swpza"));
			const long = parseFloat(localStorage.getItem("swpzo"));

			// console.log("watch Lat",lat);
			// console.log("watch long",long);
			success({ coords: { 
		      latitude: lat, 
		      longitude: long,
		  }, timestamp: Date.now() }); 
		}
	}

	function getLocation() {
	  window.navigator.geolocation.getCurrentPosition(showPosition);
	}
	function getWatchLocation() {
	  window.navigator.geolocation.watchPosition(showWatchPosition);
	}

	function showPosition(position) {
		// console.log("showPosition lat:",position.coords.latitude,"long:",position.coords.longitude);
		localStorage.setItem("swpzCurrentLatitude", position.coords.latitude);
		localStorage.setItem("swpzCurrentLongitude", position.coords.longitude);
	}
	function showWatchPosition(position) {
		
		// console.log("showWatchPosition lat:",position.coords.latitude,"long:",position.coords.longitude);
		localStorage.setItem("swpzCurrentLatitude", position.coords.latitude);
		localStorage.setItem("swpzCurrentLongitude", position.coords.longitude);

		let lat = position.coords.latitude;
		let long = position.coords.longitude;

		if(overrideLocation){
			if(lat < realLat || lat > realLat || long < realLong || long > realLong){
				// console.log("retry overWriteGeolocation")
				overWriteGeolocation();
			}
		}
	}

	getLocation();
	getWatchLocation();
}


geolocationSpoofer();
